---
title: MutationObserver.MutationObserver()
slug: Web/API/MutationObserver/MutationObserver
tags:
  - API
  - Changes
  - Constructor
  - DOM
  - DOM Changes
  - DOM Reference
  - DOM Tree
  - Mutation Observer API
  - MutationObserver
  - Observing
  - Reference
---
<div>{{APIRef("DOM WHATWG")}}</div>

<p><span class="seoSummary">The DOM <code><strong>MutationObserver()</strong></code> constructor — part of the {{domxref("MutationObserver")}} interface — creates and returns a new observer which invokes a specified callback when DOM events occur.</span> DOM observation does not begin immediately; the {{domxref("MutationObserver.observe", "observe()")}} method must be called first to establish which portion of the DOM to watch and what kinds of changes to watch for.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>observer</var> = new MutationObserver(<var>callback</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>
 <p>A function which will be called on each DOM change that qualifies given the observed node or subtree and options.</p>

 <p>The <code><var>callback</var></code> function takes as input two parameters:</p>

 <ol>
  <li>An array of {{domxref("MutationRecord")}} objects, describing each change that occurred; and</li>
  <li>
   <p>the {{domxref("MutationObserver")}} which invoked the <code><var>callback</var></code>.</p>
  </li>
 </ol>

 <p>See the {{anch("Example", "example")}} below for more details.</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("MutationObserver")}} object, configured to call the specified <code><var>callback</var></code> when DOM mutations occur.</p>

<h2 id="Example">Example</h2>

<p>This example creates a new <code>MutationObserver</code> configured to watch a node and all of its children for additions and removals of elements to the tree, as well as any changes to attributes on any of the elements in the tree.</p>

<h3 id="The_callback_function">The callback function</h3>

<pre class="brush: js notranslate">function callback(mutationList, observer) {
  mutationList.forEach( (mutation) =&gt; {
    switch(mutation.type) {
      case 'childList':
        /* One or more children have been added to and/or removed
           from the tree.
           (See mutation.addedNodes and mutation.removedNodes.) */
        break;
      case 'attributes':
        /* An attribute value changed on the element in
           mutation.target.
           The attribute name is in mutation.attributeName, and
           its previous value is in mutation.oldValue. */
        break;
    }
  });
}
</pre>

<p>The <code>callback()</code> function is invoked when the observer sees changes matching the configuration of the observation request specified when calling {{domxref("MutationObserver.observe", "observe()")}} to begin watching the DOM.</p>

<p>The kind of change that took place (either a change to the list of children, or a change to an attribute) is detected by looking at the {{domxref("MutationRecord.type", "mutation.type")}} property.</p>

<h3 id="Creating_and_starting_the_observer">Creating and starting the observer</h3>

<p>This code actually sets up the observation process.</p>

<pre class="brush: js notranslate">const targetNode = document.querySelector("#someElement");
const observerOptions = {
  childList: true,
  attributes: true,

  // Omit (or set to false) to observe only changes to the parent node
  subtree: true
}

const observer = new MutationObserver(callback);
observer.observe(targetNode, observerOptions);</pre>

<p>The desired subtree is located by finding an element with the ID <code>someElement</code>. A set of options for the observer is also established in the <code>observerOptions</code> record. In it, we specify values of <code>true</code> for both <code>childList</code> and <code>attributes</code>, so we get the information we want.</p>

<p>Then the observer is instantiated, specifying the <code>callback()</code> function. We begin observing the DOM nodes of interest by calling <code>observe()</code>, specifying the <code><var>target</var></code> node and the <code><var>options</var></code> object.</p>

<p>From this point until {{domxref("MutationObserver.disconnect", "disconnect()")}} is called, <code>callback()</code> will be called each time an element is added to or removed from the DOM tree rooted at <code><var>targetNode</var></code>, or any of those elements' attributes are changed.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-mutationobserver-mutationobserver', 'MutationObserver()')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MutationObserver.MutationObserver")}}</p>
